Halide 22.0.0 Halide compiler and libraries

Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Halide::Internal::Provide Struct Reference

This defines the value of a function at a multi-dimensional location. More...

`#include <IR.h>`

Inheritance diagram for Halide::Internal::Provide:

## Static Public Member Functions
static Stmt | make (const std::string &name, const std::vector< Expr > &values, const std::vector< Expr > &args, const Expr &predicate)

## Public Attributes
std::string | name
std::vector< Expr > | values
std::vector< Expr > | args
Expr | predicate
Public Attributes inherited from Halide::Internal::IRNode
RefCount | ref_count
| These classes are all managed with intrusive reference counting, so we also track a reference count. More...
IRNodeType | node_type
| Each IR node subclass has a unique identifier. More...

## Static Public Attributes
static const IRNodeType | _node_type = IRNodeType::Provide

## Additional Inherited Members
Public Member Functions inherited from Halide::Internal::StmtNode< Provide >
void | accept (IRVisitor *v) const override
| We use the visitor pattern to traverse IR nodes throughout the compiler, so we have a virtual accept method which accepts visitors. More...
Stmt | mutate_stmt (IRMutator *v) const override
| StmtNode ()
| ~StmtNode () override=default
Public Member Functions inherited from Halide::Internal::BaseStmtNode
| BaseStmtNode (IRNodeType t)
virtual Stmt | mutate_stmt (IRMutator *v) const =0
Public Member Functions inherited from Halide::Internal::IRNode
virtual void | accept (IRVisitor *v) const =0
| We use the visitor pattern to traverse IR nodes throughout the compiler, so we have a virtual accept method which accepts visitors. More...
| IRNode (IRNodeType t)
virtual | ~IRNode ()=default

## Detailed Description

This defines the value of a function at a multi-dimensional location.

You should think of it as a store to a multi-dimensional array. It gets lowered to a conventional Store node. The name must correspond to an output buffer or the name of an enclosing Realize node.

Definition at line 354 of file IR.h.

## Member Function Documentation

## ◆ make()

static Stmt Halide::Internal::Provide::make | ( | const std::string & | name,
|  | const std::vector< Expr > & | values,
|  | const std::vector< Expr > & | args,
|  | const Expr & | predicate
| ) |  |
| static

## Member Data Documentation

## ◆ name

std::string Halide::Internal::Provide::name

Definition at line 355 of file IR.h.

## ◆ values

std::vector<Expr> Halide::Internal::Provide::values

Definition at line 356 of file IR.h.

## ◆ args

std::vector<Expr> Halide::Internal::Provide::args

Definition at line 357 of file IR.h.

## ◆ predicate

Expr Halide::Internal::Provide::predicate

Definition at line 358 of file IR.h.

## ◆ _node_type

const IRNodeType Halide::Internal::Provide::_node_type = IRNodeType::Provide
| static

Definition at line 362 of file IR.h.

The documentation for this struct was generated from the following file:

- src/IR.h